import java.io.*;
import java.util.*;

public class Students {

 static int MaxSize=10 ;

static int readInt() throws java.io.IOException
{ BufferedReader DataIn = new BufferedReader(new InputStreamReader(System.in));
  String Input=DataIn.readLine();
  return (Integer.valueOf(Input).intValue());
}

public static char readChar() throws java.io.IOException
{ BufferedReader DataIn=new BufferedReader(new InputStreamReader(System.in));
  String Line;
  do
	Line=DataIn.readLine().trim();
  while (Line.length()==0);
  return((Line.toUpperCase().toCharArray())[0]);
}

static char getChoice(String OK)  throws java.io.IOException
{char Reply;
 do {
  Reply=readChar();
 } while (OK.indexOf(Reply,0)==-1);
 return(Reply);
}

private static String nameFormat(String Name)
{if (Name.length()==0) return("");
 return(String.valueOf(Character.toUpperCase(Name.charAt(0))+
      Name.substring(1,Name.length()).toLowerCase()));
}

static void getValues(Student[] List,IntegerObject ListSize)
                                             throws java.io.IOException
{ String Name;
  int points,hours ;
  File InputFile=new File("Students.dat");
  // Now, open a stream from the input file
  DataInputStream DataInput=new DataInputStream(new FileInputStream(InputFile));
  String Line;
  while (ListSize.GetValue()<MaxSize &&(Line=DataInput.readLine())!=null) {
     StringTokenizer Parse=new StringTokenizer(Line);
     Name=nameFormat(Parse.nextToken());
     if (Parse.hasMoreTokens()) {
       hours=Integer.valueOf(Parse.nextToken()).intValue();
       points=Integer.valueOf(Parse.nextToken()).intValue();
     }
     else points=hours=0;
     List[ListSize.GetValue()]=new Student(Name,hours,points);
     ListSize.Increment(1);
  }
}

public static void addStudent(Student[] List,IntegerObject NumberOfValues)
                                                  throws java.io.IOException
{if (NumberOfValues.GetValue()<MaxSize) {
  BufferedReader DataInput=new BufferedReader(new InputStreamReader(System.in));
  System.out.print("Enter Name >");
  System.out.flush();
  String Name=nameFormat(DataInput.readLine());

  // Need to uppercase 1st letter and lowercase the rest in Name

  System.out.print("Hours? >");
  System.out.flush();
  int hours=readInt();
  int points;
  if (hours>0) {
    System.out.print("Points? >");
    System.out.flush();
    points=readInt();
  }
  else points=0;
  List[NumberOfValues.GetValue()]=new Student(Name,hours,points);
  NumberOfValues.Increment(1);
  sortValues(List,NumberOfValues);
 }
 else
  System.out.println("List Full");
}

// Remove a student from the list;
// No precondition, i.e. name might not be there
public static void removeStudent(Student[] List,IntegerObject NumberOfValues)
                                                    throws java.io.IOException
{ BufferedReader DataInput=new BufferedReader(new InputStreamReader(System.in));
  System.out.print("Enter Name >");
  System.out.flush();
  String Name=nameFormat(DataInput.readLine());
  int idx;
  if ((idx=searchValues(List,NumberOfValues,Name)) < 0)
    failedSearch();
  else {
    for (int indx=idx;indx<NumberOfValues.GetValue()-1;indx++)
      List[indx]=List[indx+1];
    NumberOfValues.Increment(-1);
  }
}

 // Print Student Header
 static void printStudentHeader() throws java.io.IOException
 {
    System.out.println("Sorted list of Students\n");
    System.out.println("\nStudent Name        Hours      GPA");
 }

// Insertion Sort
static void sortValues(Student[] List,IntegerObject ListSize)
{ for  (int i=0;i < ListSize.GetValue() ;i++)
  {
    int j=i;
    String s =List[i].GetName();
    Student temp=List[i];
    while (( j>0) && (Student.CompareNames(List[j-1],temp) > 0))
    {
           List[j]=List[j-1];
	   j--;
    }
    List[j]=temp;
  }
}

// Linear Search
static int searchValues(Student[] List,IntegerObject ListSize,String Name)
{int idx;
 for (idx=0;idx<ListSize.GetValue() &&
              !List[idx].GetName().equalsIgnoreCase(Name);idx++);
 if (idx<ListSize.GetValue())
    return(idx);
 return(-1);
}

static void reportValues(Student[] List,IntegerObject ListSize)
                                             throws java.io.IOException
{ printStudentHeader();
  for  (int i=0;i < ListSize.GetValue() ;i++)
     System.out.println(List[i]);
}

static void failedSearch() throws java.io.IOException
{
  System.out.println(" No such Student Info Found in database ");
}

static void successSearch(Student [] List,int position)
                                                  throws java.io.IOException
{
  System.out.println(" Student Found :");
  printStudentHeader();
  System.out.println(List[position]);
}

static char editMenu() throws java.io.IOException
{System.out.println( "\nSelect:");
 System.out.println( "\tA)dd Class");
 System.out.println( "\tC)hange Grade");
 System.out.println( "\tR)emove Class");
 System.out.println( "\tP)rint Student");
 System.out.println( "\tH)ours Completed");
 System.out.println( "\tS)tudent Name");
 System.out.println( "\tE)xit");
 return (getChoice("ACRPHSE"));
}

// Input a new name for a student
static void setStudentName(Student S) throws java.io.IOException
{DataInputStream DataInput=new DataInputStream(System.in);
 String Name;
 System.out.print( "Enter Student Name >");
 System.out.flush();
 Name=DataInput.readLine();
 S.SetName(Name);
}

static void addClass(Student S) throws java.io.IOException
{int Hours;
 char Grade;
 System.out.print( "#Hours? >");
 System.out.flush();
 Hours=readInt();
 System.out.print( "Grade? (A-D,F) >");
 System.out.flush();
 Grade=getChoice("ABCDF");;
 S.AddClass(Hours,Grade);
}

static void changeClass(Student S) throws java.io.IOException
{int Hours;
 char OldGrade,NewGrade;
 System.out.print( "#Hours? >");
 System.out.flush();
 Hours=readInt();
 System.out.print( "Old Grade? (A-D,F) >");
 System.out.flush();
 OldGrade=getChoice("ABCDF");
 System.out.print( "New Grade? (A-D,F) >");
 System.out.flush();
 NewGrade=getChoice("ABCDF");;
 S.ChangeGrade(Hours,OldGrade,NewGrade);
}

static void removeClass(Student S) throws java.io.IOException
{int Hours;
 char Grade;
 System.out.print( "#Hours? >");
 System.out.flush();
 Hours=readInt();
 System.out.print( "Grade? (A-D,F) >");
 System.out.flush();
 Grade=getChoice("ABCDF");;
 S.RemoveClass(Hours,Grade);
}


public static void editStudent(Student[] List,IntegerObject NumberOfValues)
                                                  throws java.io.IOException
{    DataInputStream DataInput=new DataInputStream(System.in);
     System.out.print(" Enter Student Name>");
     System.out.flush();
     String Name = DataInput.readLine();
     int idx;
     if ((idx=searchValues(List,NumberOfValues,Name)) < 0)
        failedSearch();
	 else {
                successSearch(List,idx);
		char choice;
		do {
			choice=editMenu();
			switch (choice) {
				case 'A':addClass(List[idx]);break;
				case 'C':changeClass(List[idx]);break;
				case 'R':removeClass(List[idx]);break;
				case 'P':printStudentHeader();
					 System.out.println(List[idx]);
					 break;
				case 'H':System.out.println("Total Hours:"+
                                             List[idx].HoursCompleted()+"\n");
			                     break;
		                case 'S':setStudentName((Student)List[idx]);
			}  // switch
		}while (choice!='E');
	} // else
}  // editStudent

public static char mainMenu() throws java.io.IOException
{System.out.println("Enter Choice");
 System.out.println("A)dd Student");
 System.out.println("E)dit Student");
 System.out.println("R)emove Student");
 System.out.println("P)rint List");
 System.out.println("Q)uit the Program");
 return getChoice("AERSPQ");
}

public static void main(String[] args) throws java.io.IOException
{
 Student[] StudentList = new Student[MaxSize];
 IntegerObject NumberOfValues=new IntegerObject(),
               Position = new IntegerObject();
 DataInputStream DataInput=new DataInputStream(System.in);

 getValues(StudentList,NumberOfValues);
 sortValues(StudentList,NumberOfValues);
 reportValues(StudentList,NumberOfValues);
 System.out.println("\n");
 char choice;
 do {
	 choice=mainMenu();
	 switch (choice) {
	 case 'A':addStudent(StudentList,NumberOfValues);
			  break;
	 case 'E':editStudent(StudentList,NumberOfValues);
			  break;
	 case 'R':removeStudent(StudentList,NumberOfValues);
			  break;
	 case 'P':reportValues(StudentList,NumberOfValues);
			  System.out.println("\n\n");
	 }
 }while (choice!='Q');

} // end of main()


} // end class

